<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012 Jigal van Hemert (jigal.van.hemert@typo3.org)
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *  A copy is found in the textfile GPL.txt and important notices to the license
 *  from the author is found in LICENSE.txt distributed with these scripts.
 *
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Analyse and fix non-utf8 databases
 *
 * @author	Jigal van Hemert <jigal.van.hemert@typo3.org>
 * @package TYPO3
 * @subpackage core
 */


 error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED);

$PATH_thisScript = str_replace('//', '/', str_replace('\\', '/',
	(PHP_SAPI == 'fpm-fcgi' || PHP_SAPI == 'cgi' || PHP_SAPI == 'isapi' || PHP_SAPI == 'cgi-fcgi') &&
			($_SERVER['ORIG_PATH_TRANSLATED'] ? $_SERVER['ORIG_PATH_TRANSLATED'] : $_SERVER['PATH_TRANSLATED'])
			? ($_SERVER['ORIG_PATH_TRANSLATED'] ? $_SERVER['ORIG_PATH_TRANSLATED'] : $_SERVER['PATH_TRANSLATED'])
			: ($_SERVER['ORIG_SCRIPT_FILENAME'] ? $_SERVER['ORIG_SCRIPT_FILENAME'] : $_SERVER['SCRIPT_FILENAME'])));

$PATH_site = dirname(dirname(dirname($PATH_thisScript)));
define('TYPO3_MODE', 'BE');

$enableInstallToolFile = $PATH_site . '/typo3conf/ENABLE_INSTALL_TOOL';

	// Additional security measure if ENABLE_INSTALL_TOOL file cannot, but
	// should be deleted (in case it is write-protected, for example).
$removeInstallToolFileFailed = FALSE;

	// Only allow Database UTF-8 Tool access if the file "typo3conf/ENABLE_INSTALL_TOOL" is found
if (is_file($enableInstallToolFile) && (time() - filemtime($enableInstallToolFile) > 3600)) {
	$content = file_get_contents($enableInstallToolFile);
	$verifyString = 'KEEP_FILE';

	if (trim($content) !== $verifyString) {
			// Delete the file if it is older than 3600s (1 hour)
		if (!@unlink($enableInstallToolFile)) {
			$removeInstallToolFileFailed = TRUE;
		}
	}
}

if (!is_file($enableInstallToolFile) || $removeInstallToolFileFailed) {
	header('Content-Type: text/html; charset=utf-8');
	header('Cache-Control: no-cache, must-revalidate');
	header('Pragma: no-cache');

	echo <<<EOL
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html
     PUBLIC "-//W3C//DTD XHTML 1.1//EN"
     "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">

	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>Database UTF-8 tool</title>
		<style type="text/css">
		body {
			background: url("../sysext/t3skin/images/login/background.png") repeat-x fixed 0 0 #4F4F4F;
			height: auto;
			margin: 0;
			padding-top: 75px;
			font: 62.8% Verdana,Arial,Helvetica,sans-serif;
		}
		div#container {
			margin: 30px 16% 10px;
			width: 456px;
			font-size: 110%;
			line-height: 1.7em;
		}
		h1 {
			background: url("../sysext/t3skin/images/login/typo3logo-white-greyback.gif") no-repeat;
			width: 124px;
			height: 34px;
			overflow: hidden;
			text-indent: -9999px;
		}
		h2 {
			margin-top: 0;
		}
		.typo3-message {
			background-position: 1.2em 1.8em;
			background-repeat: no-repeat;
			color: #9E7D4A;
			padding: 1.5em 1.5em 1em 3.5em;
		}
		.message-warning {
			background-color: #FBF6DE;
			background-image: url("../gfx/warning.png");
			border-color: #B1905C;
		}
		</style>
	</head>
	<body>
		<div id="container">
			<h1>TYPO3</h1>
			<div class="typo3-message message-warning">
				<h2>The Database UTF-8 Tool is locked</h2>
				<p>
					To enable the Database UTF-8 Tool, the file ENABLE_INSTALL_TOOL must be created.
				</p>
				<p>
					In the typo3conf/ folder, create a file named ENABLE_INSTALL_TOOL. The file name is
					case sensitive, but the file itself can simply be an empty file.
				</p>
				<p>
					For security reasons, it is highly recommended that you either rename or delete the file after the operation is finished.
				</p>
				<p>
					As an additional security measure, if the file is older than one hour, TYPO3 will automatically delete it. The file must be writable by the web server user.
				</p>
			</div>
		</div>
	</body>
</html>
EOL;
	exit();
}

require_once($PATH_site . '/typo3conf/localconf.php');
startOutput();

$problems = array();

$db = mysql_connect($typo_db_host, $typo_db_username, $typo_db_password, TRUE);
if (!is_resource($db)) {
	endWithError("Could not connect to db!: " . mysql_error());
}
if (mysql_select_db($typo_db, $db) === FALSE) {
	endWithError("Could not select database!: " . mysql_error());
}

if ($_POST['fixtype']) {

	switch ($_POST['fixtype']) {
		case 1:
			$mode = 1;
			break;
		case 2:
			$mode = 2;
			break;
		default:
			endWithError('Invalid conversion type.');
	}
		// start database manipulation
	echo '<h2>Database conversion</h2>';
	displayProgressBar();

	$tables = array();
	$typeconv = array(
		'char' => 'binary',
		'text' => 'blob',
	);

	$sql = 'SHOW TABLES;';
	$databaseResource = mysql_query($sql, $db);
	if (!is_resource($databaseResource)) {
		endWithError('Could not get query result!: ' . mysql_error());
	}
	while ($row = mysql_fetch_array($databaseResource, MYSQL_NUM)) {
		$tables[] = $row[0];
	}
	$numberOfTables = count($tables);
	$i =0;

		// process each table
	foreach ($tables as $table) {
			// Collect column information
		$sql = 'SHOW FULL COLUMNS FROM `' . $table . '`;';
		$databaseResource = mysql_query($sql, $db);
		if (!is_resource($databaseResource)) {
			endWithError('Could not get table data!: ' . mysql_error());
		}
		$columns = array();
		progress( ++$i * 99 / $numberOfTables, $table);
		while ($row = mysql_fetch_assoc($databaseResource)) {
			$columns[] = $row;
		}
		// process each column
		foreach ($columns as $column) {
			set_time_limit(60);
			$oldtype = $column['Type'];
			// modify type into a binary equivalent
			$column['Type'] = str_replace(array_keys($typeconv), array_values($typeconv), $column['Type']);
			// only do the magic if the type was modified
			if ($column['Type'] != $oldtype) {
				$column['Null'] = (strtolower($column['Null']) == 'yes') ? 'NULL' : 'NOT NULL';
				$column['Default'] = (is_numeric($column['Default']))
					? $column['Default']
				: ($column['Default'] === 'NULL') ? $column['Default'] : '\'' . $column['Default'] . '\'';
				// modify type to binary equivalent to let MySQL believe that there is no charset/collation for the data
				// only do this if required
				if ($mode == 2) {
					$sql = 'ALTER TABLE `' . $table . '` MODIFY COLUMN `' . $column['Field'] . '` ' . $column['Type'] . ' ' .
					$column['Null'];
					// only use default part if it's not a blob/text
					if (strpos($column['Type'], 'blob') === FALSE) {
						$sql .= ' DEFAULT ' . $column['Default'];
					}
					$sql .= ' ' . $column['Extra'] . ';';
					$databaseResource = mysql_query($sql, $db);
					if (!is_resource($databaseResource) && mysql_errno($db) != 0) {
						endWithError('Could not execute query!: ' . mysql_error($db));
					}
				}
				// modify type (back) to the non-binary equivalent, but add utf8 character set / collation setting
				$column['Type'] = str_replace(array_values($typeconv), array_keys($typeconv), $column['Type']);
				$sql = 'ALTER TABLE `' . $table . '` MODIFY COLUMN `' . $column['Field'] . '` ' . $column['Type'] .
				' CHARACTER SET utf8 COLLATE utf8_general_ci ' . $column['Null'];
				if (strpos($column['Type'], 'text') === FALSE) {
					$sql .= ' DEFAULT ' . $column['Default'];
				}
				$sql .= ' ' . $column['Extra'] . ';';
				$databaseResource = mysql_query($sql, $db);
				if (!is_resource($databaseResource) && mysql_errno($db) != 0) {
					endWithError('Could not execute query!: ' . mysql_error($db));
				}
			}
		}

		// set defaults for table to utf8
		$sql = 'ALTER TABLE `' . $table . '` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;';
		$databaseResource = mysql_query($sql, $db);
		if (!is_resource($databaseResource) && mysql_errno($db) != 0) {
			endWithError('Could not execute query!: ' . mysql_error($db));
		}

	}
		// set defaults for database to utf8
	$sql = 'ALTER DATABASE `' . $typo_db . '` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci;';
	$databaseResource = mysql_query($sql, $db);
	if (!is_resource($databaseResource) && mysql_errno($db) != 0) {
		endWithError('Could not execute query!: ' . mysql_error($db));
	}
	progress(100, 'completed');
	echo <<<EOL
		<p>&nbsp;</p>
		<div class="typo3-message message-ok"><h2>Completed!</h2>
		<p>All data in the database is now UTF-8 and the default character set for all tables and the database itself is also set to UTF-8.</p>
		</div>
EOL;

	endOutput();

} else {
		// Analyze database

	echo '<h2>Database analysis</h2>';
	displayProgressBar();

		// 1. check if the database is utf-8

	$sql = 'SHOW VARIABLES LIKE \'character_set_database\';';
	$databaseResource = mysql_query($sql, $db);
	if (!is_resource($databaseResource)) {
		endWithError('Query failed: ' . mysql_error());
	}
	$row = mysql_fetch_assoc($databaseResource);
	$variableValue = $row['Value'];
	progress(1);
	if ($variableValue != 'utf8') {
		$problems[] = 'Character set of database is not UTF-8';
	} else {
		succeeded('Database character set is UTF-8');
	}

		// 2. check if all tables are utf-8
	$sql = 'SHOW TABLES;';
	$databaseResource = mysql_query($sql, $db);
	if (!is_resource($databaseResource)) {
		endWithError('Query failed: ' . mysql_error());
	}
	$tables = array();
	while ($row = mysql_fetch_array($databaseResource, MYSQL_NUM)) {
		$tables[] = $row[0];
	}
	$problemCounter = 0;
	$numberOfTables = count($tables);
	$i = 0;
	foreach ($tables as $table) {
		$sql = 'SHOW TABLE STATUS LIKE \'' . mysql_real_escape_string($table, $db) . '\';';
		$databaseResource = mysql_query($sql, $db);
		$row = mysql_fetch_assoc($databaseResource);
		progress(1 + (++$i * 19 / $numberOfTables));
			// collation starts with 'utf8'?
		if (substr($row['Collation'], 0, 4) !== 'utf8') {
			$problemCounter++;
		}
	}
	if ($problemCounter > 0) {
		$problems[] = 'Character set of ' . $problemCounter . ' table(s) is not UTF-8';
	} else {
		succeeded('Character set of all tables is UTF-8');
	}


		// 3. check if all columns are utf-8
	$problemCounter = 0;
	$checkColumns = array();
	$i = 0;
	foreach ($tables as $table) {
		$sql = 'SHOW FULL COLUMNS FROM `' . mysql_real_escape_string($table, $db) . '` WHERE COLLATION NOT LIKE \'utf8%\';';
		$databaseResource = mysql_query($sql, $db);
		progress(20 + (++$i * 30 / $numberOfTables));
		while ($row = mysql_fetch_assoc($databaseResource)) {
			$problemCounter++;
			$checkColumns[$table][] = $row['Field'];
		}
	}
	if ($problemCounter > 0) {
		$problems[] = 'Character set of ' . $problemCounter . ' column(s) is not UTF-8';
	} else {
		succeeded('Character set of all columns is UTF-8');
	}

		// If either of the tests fail, perform next check:
		// 4. detect possible utf-8 encoded data in non-utf-8 columns
	$totalNumberOfColumns = $problemCounter;
	$problemCounter = 0;
	if ($problems) {
		$i = 0;
		foreach ($checkColumns as $table => $columns) {
			foreach ($columns as $column) {
				$sql = 'SELECT COUNT(*) AS `cnt` FROM `' . mysql_real_escape_string($table, $db) . '` WHERE CONVERT(`' .
					mysql_real_escape_string($column, $db) . '` USING latin1) REGEXP \'[Â-ß][€-¿]|[à-ï][€-¿][€-¿]|[ð-ô][€-¿][€-¿][€-¿]\'';
				$databaseResource = mysql_query($sql, $db);
				$row = mysql_fetch_assoc($databaseResource);
				if ($row['cnt'] > 0) {
					$problemCounter++;
				}
				progress(50 + (++$i * 50 / $totalNumberOfColumns));
			}
		}
	}
	progress(100);

	if ($problemCounter > 0) {
		$problems[] = $problemCounter . ' column(s) seem to contain UTF-8 encoded data in non-UTF8 fields';
	} else {
		succeeded('All columns seem to contain correctly encoded data');
	}

	if (!$problems) {
			// If they all succeeded report that no action is needed
		echo <<<EOL
		<p>&nbsp;</p>
		<div class="typo3-message message-ok"><h2>No problems detected</h2>
		<p>All checks succeeded. If there is trouble with displaying special characters this script cannot fix them for you.</p>
		</div>
EOL;
		endOutput();
	} else {
			// Display problems
		echo '<p>The following problems were detected: <ul class="problem">';
		foreach ($problems as $problem) {
			echo '<li>' . htmlspecialchars($problem) . '</li>';
		}
		echo '</ul></p>';

		if ($problemCounter > 0) {
				// incorrectly encoded data
			echo <<<EOL
		<p>Based on the test results it's best to fix encoding problems and set all database tables to UTF-8.</p>
		<div class="typo3-message message-warning"><h2>Back-up your data!</h2>
		<p>Make sure you have a back-up of your database before clicking the button below</p>
		</div>
		<p>&nbsp;</p>
		<div class="typo3-message message-information"><h2>Clear data you don't need</h2>
		<p>Fixing encoding in data can take a long time for large tables. Because you probably need to clear the caches
		anyway to see the fixed data, you could empty cache tables, search indexes, etc. before starting the conversion.</p>
		</div>
EOL;
			displayButton(2);
		} else {
				// just conversion to utf-8 needed
			echo <<<EOL
		<p>Based on the test results it's only necessary to set all database tables to UTF-8.</p>
		<div class="typo3-message message-warning"><h2>Back-up your data!</h2>
		<p>Make sure you have a back-up of your database before clicking the button below</p>
		</div>
EOL;
			displayButton(1);
		}
		endOutput();
	}
}

function startOutput() {
	header('Content-Type: text/html; charset=utf-8');
	header('Cache-Control: no-cache, must-revalidate');
	header('Pragma: no-cache');

	echo <<<EOL
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html
     PUBLIC "-//W3C//DTD XHTML 1.1//EN"
     "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">

	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<title>Database UTF-8 tool</title>
		<style type="text/css">
		body {
			background: url("../sysext/t3skin/images/login/background.png") repeat-x fixed 0 0 #4F4F4F;
			height: auto;
			margin: 0;
			padding-top: 75px;
			font: 62.8% Verdana,Arial,Helvetica,sans-serif;
		}
		div#container {
			margin: 30px 16% 10px;
			width: 456px;
			font-size: 110%;
			line-height: 1.7em;
		}
		h1 {
			background: url("../sysext/t3skin/images/login/typo3logo-white-greyback.gif") no-repeat;
			width: 124px;
			height: 34px;
			overflow: hidden;
			text-indent: -9999px;
		}
		h2 {
			margin-top: 0;
		}
		.typo3-message {
			background-position: 1.2em 1.8em;
			background-repeat: no-repeat;
			padding: 1.5em 1.5em 1em 3.5em;
			border: 1px solid;
		}
		.message-warning {
			background-color: #FBF6DE;
			background-image: url("../gfx/warning.png");
			border-color: #B1905C;
			color: #9E7D4A;
		}
		.message-information {
			background-color: #DDEEF9;
			background-image: url("../gfx/information.png");
			border-color: #8AAFC4;
			color: #64859C;
		}
		.message-error {
			background-color: #FBB19B;
			background-image: url("../gfx/error.png");
			border-color: #DC4C42;
    		color: #AA0225;
		}
		.message-ok {
			background-color: #CDEACA;
			background-image: url("../gfx/ok.png");
			border-color: #58B548;
		    color: #3B7826;
		}
		button[type=submit] {
			background: url("../sysext/install/Resources/Public/Images/button-background.jpg") repeat-x scroll left bottom #F6F6F6;
			border: 1px solid #7C7C7C;
			color: #606060;
			cursor: pointer;
			font-size: 1.1em;
			padding: 0.3em 0.6em;
		}
		button[type=submit]:hover {
			background-color: #EDEDED;
			background-image: url("../sysext/install/Resources/Public/Images/button-background-hover.jpg");
		}
		button span {
			background-repeat: no-repeat;
			display: inline-block;
			float: none;
			height: 16px;
			margin-left: 0.6em;
			width: 16px;
		}
		button span.t3-install-form-button-icon-positive {
			background-image: url("../sysext/t3skin/images/icons/status/dialog-ok.png");
		}
		div#t3-install-box-border-top {
			background: url("../sysext/install/Resources/Public/Images/content-top.png") no-repeat scroll center bottom #3E3E3E;
			height: 3px;
		}
		div#t3-install-box-border-bottom {
			background: url("../sysext/install/Resources/Public/Images/content-bottom.png") no-repeat scroll center top #4D4C4D;
			height: 3px;
		}
		div#t3-install-box-body {
			color: #606060;
			font-size: 110%;
			line-height: 1.7em;
			padding: 0.1em 1.8em 1.8em;
			margin-bottom: 0;
			background-color: #EEEEEE;
			border: 0 none;
		}
		#progress-bar {
			background-color: #CDEACA;
			height: 20px;
		}
		.success {
			background-image: url("../sysext/t3skin/images/icons/status/dialog-ok.png");
			background-repeat: no-repeat;
			background-position: 0 0.2em;
			padding-left: 1.7em;
		}
		ul.problem {
			margin-left: 0;
			padding-left: 0;
		}
		ul.problem li {
			margin-left: 0;
			padding-left: 1.7em;
			list-style: none;
			background-image: url("../sysext/t3skin/images/icons/status/dialog-error.png");
			background-repeat: no-repeat;
			background-position: 0 0.2em;
		}
		form#fixdb {
			margin-top: 1em;
		}
		</style>
	</head>
	<body>
		<div id="container">
			<h1>TYPO3</h1>
			<div id="t3-install-box-border-top">&nbsp;</div>
			<div id="t3-install-box-body">
EOL;
}

function displayProgressBar() {
	echo <<<EOL
				<div id="progress-title">0%</div>
				<div style="width:100%; height:20px; border: 1px solid black;">
					<div id="progress-bar">&nbsp;</div>
					<div id="transparent-bar">&nbsp;</div>
				</div>
EOL;
}

/**
 * Output closing HTML
 */
function endOutput() {
	echo <<<EOL
			</div>
			<div id="t3-install-box-border-bottom">&nbsp;</div>
		</div>
	</body>
</html>
EOL;
}

/**
 * Close document with an error message
 *
 * @param string $error Error message
 */
function endWithError($error) {
	echo <<<EOL
			<div class="typo3-message message-error">
				<h2>The Database UTF-8 Tool encountered an error</h2>
				<p>
EOL;
	echo htmlspecialchars($error);
	echo '</p></div>';
	endOutput();
	exit();
}

/**
 * Update progress bar
 *
 * @param int $percentDone Percentage of progress
 * @param string $message Optional message, defaults to percentage
 */
function progress($percentDone, $message = '') {
	if ($message === '') {
		$message = $percentDone . '%';
	}
	echo ('
		<script type="text/javascript">
			document.getElementById("progress-bar").style.width = "' . $percentDone . '%";
			document.getElementById("transparent-bar").style.width = "' . (100 - $percentDone) . '%";
			document.getElementById("progress-title").firstChild.data = "' . htmlspecialchars($message) . '";
		</script>
	');
	ob_flush();
	flush();
}

/**
 * Output message for succeeded test
 *
 * @param string $message Message to display
 */
function succeeded($message) {
	echo '<div class="success">' . htmlspecialchars($message). '</div>';
}

/**
 * Output form with button to start conversion with a given mode
 *
 * @param string $mode Mode of conversion
 */
function displayButton($mode) {
	echo '<form id="fixdb" method="post"><button type="submit">Start conversion <span class="t3-install-form-button-icon-positive">&nbsp;</span></button>';
	echo '<input type="hidden" name="fixtype" value="' . $mode . '"/></form>';
}
?>